#include "coremaze.h"
#include "globalMaze.h"
CoreMaze::CoreMaze(QObject *parent) : QThread(parent)
{
    row = START_MAZE_ROW;
    col = START_MAZE_COL;
    this->changeState = true;
    rot =0;
    this->cnt=0;

}

void CoreMaze::run()
{
    row = START_MAZE_ROW;
    col = START_MAZE_COL;
    this->changeState = true;
    rot = 0;
    this->cnt = 0;
    this->key.clear();
    while(1)
    {
        if(this->key == "W" && !(maze[row][col] & 0b0001))
        {
            if(rot==0)
                row--;
            if(rot==1||rot==-3)
                col++;
            if(rot==2||rot==-2)
                row++;
            if(rot==3||rot==-1)
                col--;

            this->changeState = true;
        }
        if(this->key == "D" && !(maze[row][col] & 0b0010))
        {
            switch(rot)
            {
            case 0:
                col++;
                rot++;
                break;
            case 1:
            case -3:
                row++;
                rot++;
                break;
            case 2:
            case -2:
                col--;
                rot++;
                break;
            case 3:
            case -1:
                row--;
                rot=0;
                break;
            }
            rotWall(1);
            this->changeState = true;
        }
        if(this->key == "S" && !(maze[row][col] & 0b0100))
        {
            switch(rot)
            {
            case 0:
                row++;
                rot=2;
                break;
            case 1:
            case -3:
                col--;
                rot=3;
                break;
            case 2:
            case -2:
                row--;
                rot=0;
                break;
            case 3:
            case -1:
                col++;
                rot=1;
                break;
            }
            rotWall(1);
            rotWall(1);
            this->changeState = true;
        }
        if(this->key == "A" && !(maze[row][col] & 0b1000))
        {
            switch(rot)
            {
            case 0:
                col--;
                rot--;
                break;
            case 1:
            case -3:
                row--;
                rot=0;
                break;
            case 2:
            case -2:
                col++;
                rot--;
                break;
            case 3:
            case -1:
                row++;
                rot--;
                break;
            }
            rotWall(-1);
            this->changeState = true;
        }
        if(this->key == "G")//reset
        {
            row = START_MAZE_ROW;
            col = START_MAZE_COL;
            emit sendMessage("Ricomincia il gioco");
            sleep(2);
            this->changeState = true;
            switch(rot)
            {
                case 1:
                case -3:
                rotWall(-1);
                break;
                case 2:
                case -2:
                rotWall(-1);
                rotWall(-1);
                break;
                case 3:
                case -1:
                rotWall(1);
                break;
            }
            rot =0;
        }
        if(this->changeState)
        {
            emit setWall(maze[row][col]);
            switch ((maze[row][col]&0b1111))
            {
            case 0b0000:
                if(cnt==0)
                    emit sendMessage("Puoi andare dove vuoi!");
                if(cnt==1)
                    emit sendMessage("Tutte le vie libere!");
                if(cnt==2)
                    emit sendMessage("Non ci sono ostacoli!");
                break;
            case 0b0001:
                if(cnt==0)
                    emit sendMessage("Hai il muro davanti!");
                if(cnt==1)
                    emit sendMessage("Non puoi andare avanti!");
                if(cnt==2)
                    emit sendMessage("Hai il muro davanti!");
                break;
            case 0b0010:
                if(cnt==0)
                    emit sendMessage("Hai il muro a destra!");
                if(cnt==1)
                    emit sendMessage("Via ostruita a destra!");
                if(cnt==2)
                    emit sendMessage("Non puoi andare a destra!");
                break;
            case 0b1000:
                if(cnt==0)
                    emit sendMessage("Hai il muro a sinistra!");
                if(cnt==1)
                    emit sendMessage("Via ostruita a sinistra!");
                if(cnt==2)
                    emit sendMessage("Non puoi andare a sinistra!");
                break;
            case 0b1010:
                if(cnt==0)
                    emit sendMessage("Puoi andare avanti o tornare indietro");
                if(cnt==1)
                    emit sendMessage("Destra e sinistra hai degli ostacoli");
                if(cnt==2)
                    emit sendMessage("Puoi andare solo dritto oppure tornare indietro");
                break;
            case 0b1001:
                if(cnt==0)
                    emit sendMessage("Puoi andare a destra o tornare indietro");
                if(cnt==1)
                    emit sendMessage("Davanti e sinistra hai degli ostacoli");
                if(cnt==2)
                    emit sendMessage("Puoi andare solo destra o tornare indietro");
                break;
            case 0b0011:
                if(cnt==0)
                    emit sendMessage("Puoi andare a sinistra o tornare indietro");
                if(cnt==1)
                    emit sendMessage("Davanti e destra hai degli ostacoli");
                if(cnt==2)
                    emit sendMessage("Puoi andare solo a destra o tornare indietro");
                break;
            case 0b1011:
                if(cnt==0)
                    emit sendMessage("Puoi andare solo indietro");
                if(cnt==1)
                    emit sendMessage("Unica direzione consentita indietro");
                if(cnt==2)
                    emit sendMessage("Vicolo cieco, torna indietro");
                break;
            case 0b0100:
                if(cnt==0)
                    emit sendMessage("Hai un muro dietro");
                if(cnt==1)
                    emit sendMessage("Puoi andare dove vuoi tranne indietro");
                if(cnt==2)
                    emit sendMessage("Non puoi andare indietro");
                break;
            case 0b0101:
                if(cnt==0)
                    emit sendMessage("Puoi andare a destra o a sinistra");
                if(cnt==1)
                    emit sendMessage("Non puoi andare dritto e tornare indietro");
                if(cnt==2)
                    emit sendMessage("Hai la destra e la sinistra libere");
                break;
            case 0b0110:
                if(cnt==0)
                    emit sendMessage("Puoi andare avanti o a sinistra");
                if(cnt==1)
                    emit sendMessage("Non puoi andare a destra e tornare indietro");
                if(cnt==2)
                    emit sendMessage("Hai la sinistra libera e puoi tornare indietro");
                break;
            case 0b1100:
                if(cnt==0)
                    emit sendMessage("Puoi andare avanti o a destra");
                if(cnt==1)
                    emit sendMessage("Non puoi andare a sinistra e tornare indietro ");
                if(cnt==2)
                    emit sendMessage("Direzione consentita a destra e davanti ");
                break;
            case 0b1101:
                if(cnt==0)
                    emit sendMessage("Puoi andare a destra");
                if(cnt==1)
                    emit sendMessage("Unica direzione disponibile a destra");
                if(cnt==2)
                    emit sendMessage("Hai dei muri a sinistra, davanti, dietro");
                break;
            case 0b0111:
                if(cnt==0)
                    emit sendMessage("Puoi andare a sinistra");
                if(cnt==1)
                    emit sendMessage("Unica direzione disponibile a sinistra");
                if(cnt==2)
                    emit sendMessage("Hai dei muri a destra, davanti, dietro");
                break;
            case 0b1110:
                if(cnt==0)
                    emit sendMessage("Puoi andare avanti");
                if(cnt==1)
                    emit sendMessage("Puoi proseguire dritto");
                if(cnt==2)
                    emit sendMessage("Avanti libero");
                break;
            case 0b1111:
                if(cnt==0)
                    emit sendMessage("Mi dispiace, hai perso! Premi reset per ricominciare");
                if(cnt==1)
                    emit sendMessage("Ritenta sarai piu fortunato! Premi reset per ricominciare");
                if(cnt==2)
                    emit sendMessage("Non sei riuscito ad uscire dal labirinto! Premi reset per ricominciare");
                break;
            }
            if(maze[row][col]&16)
            {
                if(cnt==0)
                    emit sendMessage("Complimenti, hai vinto! Premi reset per ricominciare");
                if(cnt==1)
                    emit sendMessage("Complimenti, sei arrivato alla fine! Premi reset per ricominciare");
                if(cnt==2)
                    emit sendMessage("Complimenti, hai completato il labirinto! Premi reset per ricominciare");
            }
            cnt++;
            if(cnt==3)
                cnt=0;
            this->changeState = false;
        }
        this->key.clear();//cancello carattere
        msleep(50);
    }
}
void CoreMaze::rotWall(int orient)//ROTAZIONE MURI
{
    for(contRow=0;contRow<8;contRow++)
    {
        for(contCol=0;contCol<8;contCol++)
        {
            if((maze[contRow][contCol] & 0b00100000)!=32)//verifico se presenta il bit della partenza
            {
                if((maze[contRow][contCol] & 0b00010000)!=16)//verifico se presenta il bit dell'arrivo
                {
                    if(orient==-1)//ruotare a sx
                    {
                        if((maze[contRow][contCol] & 0b00001000)==8)
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-15;
                        else
                            maze[contRow][contCol]=maze[contRow][contCol]<<1;
                    }
                    else//ruotare a dx
                    {
                        if(maze[contRow][contCol]%2)
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+8;
                        else
                            maze[contRow][contCol]=maze[contRow][contCol]>>1;
                    }
                }
                else//non ha il bit dell'arrivo a 1
                {
                    if(orient==-1)//ruotare a sx
                    {
                        if((maze[contRow][contCol] & 0b00001000)==8)
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-31;
                        else
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-16;
                    }
                    else//ruotare a dx
                    {
                        if(maze[contRow][contCol]%2)
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+16;
                        else
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+8;
                    }
                }
            }
            else//non ha il bit della partenza a 1
            {
                if((maze[contRow][contCol] & 0b00010000)!=16)//verifico se presenta il bit dell'arrivo
                {
                    if(orient==-1)//ruotare a sx
                    {
                        if((maze[contRow][contCol] & 0b00001000)==8)//verifico se presenta il quarto bit
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-47;
                        else
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-32;
                    }
                    else//ruotare a dx
                    {
                        if((maze[contRow][contCol] & 0b00000001)==1)
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+24;
                        else
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+16;
                    }
                }
                else
                {
                    if(orient==-1)//ruotare a sx
                    {
                        if((maze[contRow][contCol] & 0b00001000)==8)//verifico se presenta il quarto bit
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-63;
                        else
                            maze[contRow][contCol]=(maze[contRow][contCol]<<1)-48;
                    }
                    else//ruotare a dx
                    {
                        if((maze[contRow][contCol] & 0b00000001)==1)//verifico se presenta il primo bit
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+32;
                        else
                            maze[contRow][contCol]=(maze[contRow][contCol]>>1)+24;
                    }
                }
            }
        }
    }
}
